Attribute VB_Name = "mdlEmployeesHolidays"
'   
Public hRS As New ADODB.Recordset
'            
Public bHAdd As Boolean

'   
Public Sub hViewRecord()
    With frmEmployeesHolidays
    If Not hRS.RecordCount = 0 Then
        
        .txtID = ""
        .txtName = ""
        .txtMobileNum = ""
        .cmbHolidayType = ""
        .txtDays = ""
        .txtWantedDays = ""
        .txtStartDate = ""
        .txtEndDate = ""
        .txtUntakenDays = ""
            
        If Not IsNull(hRS![tblHolidaysDetails.ID]) Then .txtID = hRS![tblHolidaysDetails.ID]
        If Not IsNull(hRS![tblEmployeesDetails.Name]) Then .txtName = hRS![tblEmployeesDetails.Name]
        If Not IsNull(hRS![tblEmployeesDetails.MobileNum]) Then .txtMobileNum = hRS![tblEmployeesDetails.MobileNum]
        If Not IsNull(hRS![tblHolidays.Holiday_Type]) Then .cmbHolidayType = hRS![tblHolidays.Holiday_Type]
        If Not IsNull(hRS![tblHolidays.Days_Count]) Then .txtDays = hRS![tblHolidays.Days_Count]
        If Not IsNull(hRS![tblHolidaysDetails.Wanted_Days]) Then .txtWantedDays = hRS![tblHolidaysDetails.Wanted_Days]
        If Not IsNull(hRS![tblHolidaysDetails.StartDate]) Then .txtStartDate = hRS![tblHolidaysDetails.StartDate]
        If Not IsNull(hRS![tblHolidaysDetails.EndDate]) Then .txtEndDate = hRS![tblHolidaysDetails.EndDate]
        .txtUntakenDays = DateDiff("d", .txtStartDate, .txtEndDate)
    End If
    End With
End Sub
'    
Public Sub hViewLen()
    Dim iPos As Integer
    Dim iCount As Integer
    
    
    frmEmployeesHolidays.lblLen.Caption = ""
    
    iPos = hRS.AbsolutePosition
    iCount = hRS.RecordCount
    If iCount < 1 Then
        frmEmployeesHolidays.lblLen.Caption = "      "
    Else
        frmEmployeesHolidays.lblLen.Caption = " " & iPos & "  " & iCount & " /   "
    End If
End Sub

'   
Public Sub AddEmployeeHoliday()
    With frmEmployeesHolidays
        .txtDays = ""
        .txtUntakenDays = ""
        .txtWantedDays = ""
        .txtStartDate = DateAdd("d", 1, Format(Now, "dd/mm/yyyy"))
        .txtEndDate = ""
        .cmbHolidayType = ""
        .Show
        .cmbHolidayType.SetFocus
        
    End With
End Sub
'   
Public Sub hEnabledUnEnabled(N As Boolean)
    With frmEmployeesHolidays
        .txtID.Locked = True
        .txtName.Locked = True
        .txtMobileNum.Locked = True
        
        .cmbHolidayType.Locked = N
        .txtDays.Locked = N
        .txtEndDate.Locked = N
        .txtStartDate.Locked = N
            
        .cmdCHEndDate.Enabled = Not N
        .cmdCHStartDate.Enabled = Not N
        
        .cmdMoveFirst.Enabled = N
        .cmdMovePrev.Enabled = N
        .cmdMoveNext.Enabled = N
        .cmdMoveLast.Enabled = N
            
        .cmdAdd.Enabled = N
        .cmdDelete.Enabled = N
        .cmdEdit.Enabled = N
                
        .cmdPrint.Enabled = N
        .cmdPrintAll.Enabled = N
        .cmdclose.Enabled = N
        
        .cmdSave.Enabled = Not N
        .cmdCancel.Enabled = Not N
            
        If hRS.RecordCount = 0 Then
            .cmdEdit.Enabled = False
            .cmdDelete.Enabled = False
        End If
    End With
End Sub

