VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SmartSizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Sub LogicalSize(ContainerObj As Object, ImgObj As Object, ByVal Cushion As Integer)
    Dim VertChg, HorzChg As Integer
    Dim iRatio As Double
    Dim ActualH, ActualW As Integer
    Dim ContH, ContW As Integer
    On Error GoTo LogicErr

    With ImgObj
        .Visible = False
        .Stretch = False
    End With

    VertChg = 0: HorzChg = 0
    ActualH = ImgObj.Height
    ActualW = ImgObj.Width
    ContH = ContainerObj.Height - Cushion
    ContW = ContainerObj.Width - Cushion
    CenterCTL ContainerObj, ImgObj


    If ImgObj.top < Cushion Or ImgObj.left < Cushion Then


        If ActualH <> ActualW Then


            If ActualH > ActualW Then
                iRatio = (ActualH / ActualW)
                HorzChg = 10
                VertChg = CInt(Format(iRatio * 10, "####"))
            Else
                iRatio = (ActualW / ActualH)
                VertChg = 10
                HorzChg = CInt(Format(iRatio * 10, "####"))
            End If
        Else
            VertChg = 10
            HorzChg = 10
        End If


        Do Until ActualH <= ContH And ActualW <= ContW
            ActualH = ActualH - VertChg
            ActualW = ActualW - HorzChg


            If ActualH < 100 Then
                ActualH = 100
                Exit Do
            ElseIf ActualW < 100 Then
                ActualW = 100
                Exit Do
            End If
        Loop



        With ImgObj
            .Stretch = True
            .Height = ActualH
            .Width = ActualW
        End With
    End If
    CenterCTL ContainerObj, ImgObj
    Exit Sub
LogicErr:
    MsgBox "An Error occured while rescaling this image. Image size maybe invalid.", vbSystemModal + vbExclamation, "Resize Error!"
End Sub


Public Sub CenterCTL(FRMObj As Object, OBJ As Control)


    With OBJ
        .top = (FRMObj.Height / 2) - (OBJ.Height / 2)
        .left = (FRMObj.Width / 2) - (OBJ.Width / 2)
        .ZOrder
    End With
End Sub

