VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmScan 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   " Scan Image"
   ClientHeight    =   9045
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10050
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9045
   ScaleWidth      =   10050
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraCapture 
      Caption         =   " Select Different Collection"
      Height          =   615
      Left            =   240
      TabIndex        =   9
      Top             =   600
      Width           =   5055
      Begin VB.ComboBox cboCapture 
         Height          =   315
         Left            =   480
         Style           =   2  'Dropdown List
         TabIndex        =   10
         Top             =   240
         Width           =   3975
      End
   End
   Begin VB.CommandButton cmdCancelCap 
      Caption         =   "Cancel"
      Height          =   450
      Left            =   3120
      TabIndex        =   8
      Top             =   120
      Width           =   2175
   End
   Begin VB.CommandButton cmdCapture 
      Caption         =   "Capture Screen"
      Height          =   450
      Left            =   240
      TabIndex        =   7
      Top             =   120
      Width           =   2055
   End
   Begin MSComDlg.CommonDialog dlgCap 
      Left            =   4800
      Top             =   4320
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ComboBox cboCat 
      Height          =   315
      Left            =   1320
      Style           =   2  'Dropdown List
      TabIndex        =   5
      Top             =   7800
      Width           =   2175
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   495
      Left            =   6360
      TabIndex        =   4
      Top             =   8280
      Width           =   3375
   End
   Begin VB.CommandButton cmdADD 
      Caption         =   "&Add Picture"
      Enabled         =   0   'False
      Height          =   495
      Left            =   360
      TabIndex        =   3
      Top             =   8280
      Width           =   3255
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   6735
      Left            =   360
      ScaleHeight     =   6675
      ScaleWidth      =   9315
      TabIndex        =   2
      Top             =   840
      Width           =   9375
      Begin VB.Image Image2 
         Height          =   375
         Left            =   0
         Top             =   0
         Width           =   375
      End
   End
   Begin VB.CommandButton cmdScan 
      Caption         =   "Scan!"
      Height          =   615
      Left            =   5520
      TabIndex        =   1
      Top             =   120
      Width           =   4215
   End
   Begin VB.CommandButton cmdSelect 
      Caption         =   "Select TWAIN Source"
      Height          =   612
      Left            =   360
      TabIndex        =   0
      Top             =   120
      Width           =   3975
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Add to:"
      Height          =   375
      Left            =   480
      TabIndex        =   6
      Top             =   7800
      Width           =   735
   End
   Begin VB.Image Image3 
      Height          =   495
      Left            =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   495
   End
End
Attribute VB_Name = "frmScan"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function TWAIN_AcquireToFilename Lib "MagTW.dll" (ByVal hwndApp As Long, ByVal bmpFileName As String) As Integer
Private Declare Function TWAIN_IsAvailable Lib "MagTW.dll" () As Long
Private Declare Function TWAIN_SelectImageSource Lib "MagTW.dll" (ByVal hwndApp As Long) As Long
Private Declare Function TWAIN_AcquireToClipboard Lib "MagTW.dll" (ByVal hwndApp As Long, ByVal wPixTypes As Long) As Long
Private Declare Function TWAIN_EasyVersion Lib "MagTW.dll" () As Long
Dim ScannedFile As String
Dim strTempDir As String
Dim DLLCheck As Boolean

Private Sub cmdADD_Click()
    Dim strScannedFile As String
    Dim lngCheckName As Long
    Dim strRes

    strRes = InputBox("Please Type a Name for This Image to Save ( No Extention )", "Save As", "Scanned_Pic")
    strScannedFile = Replace(strRes, ".", "")
    strScannedFile = Trim(strScannedFile)

    ' Check if Null
    If strScannedFile = "" Then
        MsgBox "Please type valid name", vbInformation, "Invalid Name"
        Exit Sub
    End If

    ' Must begin with valid char
    Select Case Mid(strScannedFile, 1, 1)
        Case "a" To "z"
        Case "A" To "Z"
        Case Else
            MsgBox "Please type a valid name, name must not begin with a number or special character ( /\:*?<>| etc..)", vbInformation, "Invalid Name"
            Exit Sub
    End Select

    ' Check for invalid char in between name
    For lngCheckName = 1 To Len(strScannedFile)

        Select Case Mid(strScannedFile, lngCheckName, Len(strScannedFile) - (Len(strScannedFile) - 1))
            Case "a" To "z"
            Case "A" To "Z"
            Case 0 To 9
            Case " "
            Case "_"
            Case Else
                MsgBox "Not Valid Name, don't use ( /\:*?<>| etc..)", vbInformation, "Invalid Name"
                Exit Sub
        End Select

    Next lngCheckName
    ' end check

    strScannedFile = strScannedFile & ".bmp"
    Call AddImage(strScannedFile)

End Sub

Private Sub cmdCancel_Click()
    On Error Resume Next
    Kill ScannedFile
    Unload Me
    FrmAdd.Show
End Sub

Private Sub cmdScan_Click()


    Dim Ret As Long

    On Error GoTo ScanErr

    Screen.MousePointer = 11

    strTempDir = Environ("temp")

    ScannedFile = strTempDir & "\temp.bmp"
    ScannedFile = Replace(ScannedFile, "\\", "\")


    Ret = TWAIN_AcquireToFilename(Me.hwnd, ScannedFile)

    If Ret = 0 Then
        Image3.Picture = LoadPicture(ScannedFile)

        ' Smart Size The Image to the Picture1 Box
        Set SmartSize = New SmartSizer
        SmartSize.LogicalSize Picture1, Image3, 0     '100
        Image2.Visible = False
        Image2.Width = Image3.Width
        Image2.Height = Image3.Height
        Image2.Stretch = True
        Image2.Picture = Image3.Picture
        Image2.top = Picture1.Height / 2 - Image2.Height / 2
        Image2.left = Picture1.Width / 2 - Image2.Width / 2 - 25
        Image2.Visible = True
        cmdADD.Enabled = True
        Screen.MousePointer = 0
    Else
        MsgBox "Scan not successful!", vbCritical, "Scanning"
        Screen.MousePointer = 0
        Unload Me
        FrmAdd.Show
    End If

    Exit Sub

ScanErr:
    MsgBox Err.Description, vbInformation
    Screen.MousePointer = 0
    Exit Sub

End Sub

Private Sub cmdSelect_Click()
    TWAIN_SelectImageSource (Me.hwnd)
End Sub

Private Sub AddImage(PixName As String)

    Dim Img() As Byte, i As Long, sI As String
    Dim iCountImages As Long
    Dim Tempoo As String
    Dim iAdd As Long
    Dim intDub As Long
    Dim strChangeName As Long
    Dim strTempName As String
    Dim strExt As String
    Dim strBeg As String
    Dim strEnd As String


    On Error GoTo ErrFound

    strChangeName = 1

    If blnScan = True Then
        CatName = cboCat.Text
    Else
        CatName = cboCapture.Text
    End If

    CloseDb

    Set db = OpenDatabase(dbFileName)
    Set RS = db.OpenRecordset(CatName)

    LoadList1

    RS.AddNew
    PicName = PixName


    Close #1

    Open ScannedFile For Binary As 1

    ReDim Img(LOF(1))


    Do While Not EOF(1)
        Get #1, , Img
        i = i + 1
    Loop

    Close #1

    ' If Name already in the database, add number to the end
    For intDub = 0 To FrmMain.List1.ListCount - 1
        If UCase(PicName) = UCase(FrmMain.List1.List(intDub)) Then

            strExt = InStrRev(PicName, ".", -1, vbTextCompare)

            If strExt <> 0 Then
                strBeg = Mid(PicName, 1, strExt - 1)
                strEnd = Mid(PicName, strExt)
                PicName = strBeg & "_" & strChangeName & strEnd
                strChangeName = strChangeName + 1
            Else
                PicName = PicName & strChangeName
                strChangeName = strChangeName + 1
            End If

        End If

    Next intDub

    RS.Fields(0) = PicName
    RS.Fields(1) = Img

    RS.Update

    LoadList1

    If blnScan = True Then
        MsgBox "Scanned Image Saved to Database with the Name [ " & PicName & " ] to the [ " & CatName & " ] Collection", vbInformation, "Success"
    Else
        MsgBox "Captured Image Saved to Database with the Name [ " & PicName & " ] to the [ " & CatName & " ] Collection", vbInformation, "Success"
    End If

    On Error Resume Next
    Kill ScannedFile

    Unload Me

    Exit Sub
ErrFound:
    MsgBox Err.Description, vbInformation, "Error: " & Err.Number
    Exit Sub
End Sub

Private Sub cmdCancelCap_Click()
    Call cmdCancel_Click
End Sub

Private Sub Form_Load()


    If blnScan = True Then

        Call CheckDLLFiles
        If DLLCheck <> True Then Exit Sub
        cmdCapture.Visible = False
        cmdCancelCap.Visible = False
        fraCapture.Visible = False

        For iCbo = 1 To FrmMain.TV1.Nodes.Count
            If FrmMain.TV1.Nodes.item(iCbo).Text <> "My Pictures" Then
                cboCat.AddItem FrmMain.TV1.Nodes.item(iCbo).Text
            End If
        Next iCbo
        cboCat.ListIndex = 0
    Else
        cmdCapture.Visible = True
        cmdSelect.Visible = False
        cmdScan.Visible = False
        Caption = " Capture Screen"
        frmScan.Width = 5730
        frmScan.Height = 1770
        fraCapture.Visible = True
        Picture1.Visible = False
        For iCbo = 1 To FrmMain.TV1.Nodes.Count
            If FrmMain.TV1.Nodes.item(iCbo).Text <> "My Pictures" Then
                cboCapture.AddItem FrmMain.TV1.Nodes.item(iCbo).Text
            End If
        Next iCbo
        cboCapture.ListIndex = 0
    End If



End Sub
Private Sub cmdCapture_Click()

    Dim XS, YS
    Dim Siz
    Dim Reso As String
    Dim RemoveDup
    Dim strScannedFile As String
    Dim lngCheckName As Long
    Dim strRes

    On Error Resume Next


    strRes = InputBox("Please Type a Name for This Image to Save ( No Extention )", "Save As", "Captured_File")

    If strRes = "" Then
        Unload Me
        Exit Sub
    End If

    strScannedFile = Replace(strRes, ".", "")
    strScannedFile = Trim(strScannedFile)

    ' Check if Null
    If strScannedFile = "" Then
        MsgBox "Please type valid name", vbInformation, "Invalid Name"
        Exit Sub
    End If

    ' Must begin with valid char
    Select Case Mid(strScannedFile, 1, 1)
        Case "a" To "z"
        Case "A" To "Z"
        Case Else
            MsgBox "Please type a valid name, name must not begin with a number or special character ( /\:*?<>| etc..)", vbInformation, "Invalid Name"
            Exit Sub
    End Select

    ' Check for invalid char in between name
    For lngCheckName = 1 To Len(strScannedFile)

        Select Case Mid(strScannedFile, lngCheckName, Len(strScannedFile) - (Len(strScannedFile) - 1))
            Case "a" To "z"
            Case "A" To "Z"
            Case 0 To 9
            Case " "
            Case "_"
            Case Else
                MsgBox "Not Valid Name, don't use ( /\:*?<>| etc..)", vbInformation, "Invalid Name"
                Exit Sub
        End Select

    Next lngCheckName
    ' end check

    frmScan.Hide
    FrmMain.Hide

    DoEvents

    ScreenCapture 0, 0, Screen.Width / Screen.TwipsPerPixelX, Screen.Height / Screen.TwipsPerPixelY
    Image3.Picture = Clipboard.GetData()


    frmScan.Show
    FrmMain.Show

    XS = ScaleX(Image3.Width, vbTwips, vbPixels) - 4
    YS = ScaleY(Image3.Height, vbTwips, vbPixels) - 4

    Siz = XS & "," & YS
    Caption = Siz


    strScannedFile = strScannedFile & ".bmp"
    ScannedFile = TemDir & "\" & strScannedFile
    ScannedFile = Replace(ScannedFile, "\\", "\")
    SavePicture Image3, ScannedFile

    Call AddImage(strScannedFile)

End Sub
Private Sub ScreenCapture(left As Long, top As Long, right As Long, bottom As Long)

    Dim capWidth As Long, capHeight As Long
    Dim Srcdc, Destdc, Hbmp

    capWidth = right - left
    capHeight = bottom - top
    Srcdc = CreateDC("DISPLAY", 0, 0, 0)
    Destdc = CreateCompatibleDC(Srcdc)
    Hbmp = CreateCompatibleBitmap(Srcdc, capWidth, capHeight)
    SelectObject Destdc, Hbmp
    BitBlt Destdc, 0, 0, capWidth, capHeight, Srcdc, left, top, &HCC0020
    OpenClipboard Screen.ActiveForm.hwnd
    EmptyClipboard
    SetClipboardData 2, Hbmp
    CloseClipBoard
    DeleteObject Hbmp
    DeleteDC Destdc
    ReleaseDC 0, Srcdc

End Sub


Public Sub CheckDLLFiles()

    Dim WIN_Dir As String
    Dim SYS_Dir As String
    Dim TW_File As String
    Dim S_File, D_File, strMsg

    DLLCheck = False

    WIN_Dir = Environ("windir")
    SYS_Dir = WIN_Dir & "\SYSTEM32"

    If WIN_Dir = "" Or SYS_Dir = "" Then
        MsgBox "Could not find your system32 directory", vbInformation
        DLLCheck = False
        Exit Sub
    End If


    TW_File = SYS_Dir & "\MagTW.dll"
    TW_File = Replace(TW_File, "\\", "\")

    ' Check for the TWAIN file in the SYSTEM32 Directory
    Close #1
    Open TW_File For Binary As #1

    LenDb = LOF(1)
    If LenDb <> 0 Then
        ' IF TWAIN File Exist
        Close #1
        DLLCheck = True
        Exit Sub
    Else
        ' Does not Exist, Copy it
        Close #1
        GoTo DO_COPY
    End If

DO_COPY:

    S_File = App.Path & "\MagTW.dll"
    D_File = TW_File

    On Error GoTo ErrCopy

    FileCopy S_File, D_File

    DLLCheck = True
    Exit Sub

ErrCopy:
    strMsg = "Could not copy [MagTW.dll], please copy this file to [SYSTEM32] directory" & vbCrLf & _
            "located at the windows directory and then try again" & vbCrLf & _
            "The [MagTW.dll] can be found in the same directory of this program"
    MsgBox strMsg, vbInformation
    DLLCheck = False
    Unload Me
    Exit Sub
End Sub
