VERSION 5.00
Begin VB.Form frmMenu 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   Icon            =   "frmMenu.frx":0000
   LinkTopic       =   "Form1"
   RightToLeft     =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuRtb 
      Caption         =   "#"
      Begin VB.Menu mnuTop 
         Caption         =   "  "
      End
      Begin VB.Menu Sp0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuStartItem 
         Caption         =   " "
      End
      Begin VB.Menu mnuPreviousItem 
         Caption         =   ""
      End
      Begin VB.Menu Sp1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSelectItem 
         Caption         =   " "
      End
      Begin VB.Menu mnuCopyItem 
         Caption         =   ""
      End
      Begin VB.Menu mnuPrintItem 
         Caption         =   ""
      End
      Begin VB.Menu Sp3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExplorerItem 
         Caption         =   ""
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuTvw 
      Caption         =   "#"
      Begin VB.Menu mnuEditItem 
         Caption         =   " ..."
      End
      Begin VB.Menu mnuRenameItem 
         Caption         =   " "
      End
      Begin VB.Menu mnuRemoveItem 
         Caption         =   ""
      End
      Begin VB.Menu Sp4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExtractItem 
         Caption         =   " ..."
      End
   End
End
Attribute VB_Name = "frmMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub mnuCopyItem_Click()
    If frmMain.Rtb.Text = "" Then Exit Sub
    Clipboard.Clear
    If frmMain.Rtb.SelText <> "" Then
        Clipboard.SetText frmMain.Rtb.SelText
    Else
        Clipboard.SetText frmMain.Rtb.Text
    End If
End Sub
Private Sub mnuEditItem_Click()
    If Signature = "WRK FILE" Then Exit Sub
    If frmMain.tvw.SelectedItem Is Nothing Then Exit Sub
    Call ShellExecute(0&, vbNullString, frmMain.tvw.SelectedItem.Tag, "", vbNullString, SW_NORMAL)
End Sub
Private Sub mnuExplorerItem_Click()
    frmMain.mnuSelectorItem.Checked = Not frmMain.mnuSelectorItem.Checked
    mnuExplorerItem.Checked = frmMain.mnuSelectorItem.Checked
    frmMain.Explorer.Visible = frmMain.mnuSelectorItem.Checked
    frmMain.Search.Visible = frmMain.mnuSelectorItem.Checked
    If frmMain.Explorer.Visible = True Then
        frmMain.tbr.Buttons("Selector").Value = tbrPressed
        frmMain.Rtb.Width = frmMain.Spilter.Left
    Else
        frmMain.tbr.Buttons("Selector").Value = tbrUnpressed
        frmMain.Rtb.Width = frmMain.ScaleWidth
    End If
End Sub
Private Sub mnuExtractItem_Click()
    On Error GoTo ErrHndlr
    If frmMain.tvw.SelectedItem Is Nothing Then Exit Sub
    If frmMain.Rtb.Text = "" Then Exit Sub
    If Signature = "WRP FILE" Then Exit Sub
    frmMain.Dlg.FileName = frmMain.tvw.SelectedItem.Text
    frmMain.Dlg.DefaultExt = "rtf"
    frmMain.Dlg.Filter = " |*rtf"
    frmMain.Dlg.Flags = cdlOFNOverwritePrompt
    frmMain.Dlg.DialogTitle = " "
    frmMain.Dlg.ShowSave
    frmMain.Rtb.SaveFile frmMain.Dlg.FileName
    Exit Sub
ErrHndlr:
    Select Case Err.Number
        Case 32755
        
        Case Else
            MsgBox Err.Number & vbCrLf & Err.Description, vbMsgBoxRight Or vbMsgBoxRtlReading, " "
    End Select
End Sub

Private Sub mnuNextItem_Click()

End Sub

Private Sub mnuPreviousItem_Click()
    On Error GoTo ErrHndlr
    If PrevPage = "" Then Exit Sub
    LoadPage frmMain.tvw.Nodes(PrevPage), frmMain.Rtb, 0
    MakeLinkPage frmMain.tvw.Nodes(CurrPage)
    frmMain.sbr.Panels(2).Text = ""
    Set frmMain.tvw.SelectedItem = frmMain.tvw.Nodes(CurrPage)
    Exit Sub
ErrHndlr:
    
End Sub

Private Sub mnuPrintItem_Click()
    On Error GoTo ErrHndlr
    PrintRTF frmMain.Rtb, _
    PageRect.Left * 567, _
    PageRect.Right * 567, _
    PageRect.Top * 567, _
    PageRect.Bottom * 567
    Exit Sub
ErrHndlr:
    Select Case Err.Number
        Case 32755
        Case Else
            MsgBox Err.Description & vbCrLf & Err.Description, vbMsgBoxRight Or vbMsgBoxRtlReading, " "
    End Select
End Sub

Private Sub mnuRemoveItem_Click()
    If Signature = "WRK FILE" Then Exit Sub
    If frmMain.tvw.SelectedItem Is Nothing Then Exit Sub
    Dim Rep As Integer
    Dim Msg As String
    If frmMain.tvw.SelectedItem.Children = 0 Then
        Msg = "     "
    Else
        Msg = "        "
    End If
    Rep = MsgBox(Msg, vbYesNo Or vbMsgBoxRtlReading Or vbMsgBoxRight, " ")
    If Rep = vbNo Then Exit Sub
    Dim Idx As Integer
    frmMain.tvw.Nodes.Remove (frmMain.tvw.SelectedItem.Key)
    frmMain.Rtb.Text = ""
    For Idx = 1 To frmMain.tvw.Nodes.Count
        frmMain.tvw.Nodes(Idx).Key = "E" & Idx
        If frmMain.tvw.Nodes(Idx).Children = 0 Then
            frmMain.tvw.Nodes(Idx).Image = "Doc"
            frmMain.tvw.Nodes(Idx).Expanded = False
        End If
    Next Idx
    BckSave = True
End Sub
Private Sub mnuRenameItem_Click()
    If Signature = "WRK FILE" Then Exit Sub
    frmMain.tvw.StartLabelEdit
End Sub
Private Sub mnuSelectItem_Click()
    If frmMain.Rtb.Text = "" Then Exit Sub
    frmMain.Rtb.SelStart = 0
    frmMain.Rtb.SelLength = Len(frmMain.Rtb.Text)
End Sub
Private Sub mnuStartItem_Click()
    On Error GoTo ErrHndlr
    LoadPage frmMain.tvw.Nodes(1), frmMain.Rtb, 0
    MakeLinkPage frmMain.tvw.Nodes(1)
    frmMain.sbr.Panels(2).Text = ""
    Set frmMain.tvw.SelectedItem = frmMain.tvw.Nodes(1)
    Exit Sub
ErrHndlr:
    
End Sub
Private Sub mnuTop_Click()
    frmMain.Rtb.SelStart = 0
End Sub
